/**
* We Are Everywhere
*
* @author  Luke Mourino
* Cookie code
* Repurposed from http://www.quirksmode.org/js/cookies.html
*
*/

/**
 * Single global namespace
 * @type {Object}
 */
var bare = bare || {};
var utils = bare.utils;

/**
 * Create re-usable 'Cookies' class
 * @return {object} Cookies
 */
bare.Cookies = (function() {

	/**
	* Start
	* @constructor
	* @return {Cookies}
	*/
	function Cookies() {
		var self = this;

		this.hasVisited = self.tasteCookie('hasVisted');
		
		self.init();
		
		return this;
	}

	/**
	* Create a reference to GeneralLayout.prototype for neatness
	* @type {object}
	*/
	var CookieProto = Cookies.prototype;

	CookieProto.init = function(){

		var self = this;

		if(!self.hasVisited) {
			console.log("hasVisted: ", self.hasVisited);
			self.bakeCookie('hasVisted', 'true', 90);
		}

		return this;
	
	};

	/**
	* read the cookie
	* @return {[type]} [description]
	*/
	CookieProto.tasteCookie = function(name){
		var nameEQ = name + "=";
		var ca = document.cookie.split(';');
		
		for(var i=0;i < ca.length;i++) {
			var c = ca[i];
			
			while (c.charAt(0)==' ') c = c.substring(1,c.length);
			
			if (c.indexOf(nameEQ) === 0) return c.substring(nameEQ.length,c.length);
		
		}
		
		return null;
	};

	/**
	* create delicious cookie
	* @return {[type]} [description]
	*/
	CookieProto.bakeCookie = function(name, value, days){
		var expires = "";
		
		if (days) {
			var date = new Date();
			date.setTime(date.getTime()+(days*24*60*60*1000));
			expires = "; expires="+date.toGMTString();
		}
		else expires = "";
		document.cookie = name+"="+value+expires+"; path=/";

		return this;
	};

	/**
	* kill the cookie
	* @return {[type]} [description]
	*/
	CookieProto.eatCookie = function(name){
		var self = this;
		
		self.bakeCookie(name,"",-1);
		
		return this;
	};

	return Cookies;

})();