var bare = bare || {};
var FilteringClass = function() {};

FilteringClass.prototype = function(){
		
	var Filter = function(options){
	
		this.listClass = options.listClass || '.filter-list';
		this.titleItem = options.titleItem || '.title';
		this.selectedItem = options.selectedItems || '.selected';
		this.init();
			
	},
	createFilter = function(options) {
		
		var x = new Filter(options);

	};

	Filter.prototype.init = function(){
		var self = this;

		$(".filter-search-form input.spyglass").on("click", function(){
			$(this).parent("form").submit();
			return false;
		});

		//$('.filter-title').on('click', this.toggleFilterVisibility.bind(this));
		$('.filter-submit').on('click', this.getAllFilterOptions.bind(this));
		$('.filtering .contain-checkboxes li').on('click', this.maintainCheckboxes.bind(this));
		$('.filter-clear-all').on('click', this.clearAllCheckboxes.bind(this));
		$('.filter-select-all').on('click', this.selectAllCheckboxes.bind(this));
		$('.filter-select-all-checkbox').on('click', this.selectSectionBoxes.bind(this));
		$('form.filter-search-form.filters').on('submit', this.customSearch.bind(this));


		if(bare.isMobile) {
			
			//hide all filter options in container - should use css
			$('.filtering h4').on('click', this.showHideSectionMobile.bind(this));
		}
	};

	Filter.prototype.customSearch = function(e){
		e.preventDefault();
		
		this.getAllFilterOptions();
		
		return false;
	};

	Filter.prototype.showHideSectionMobile = function(e){
		var $this = $(e.target),
			$container = $this.parent();

		$container.toggleClass('mobile-show');
	};

	Filter.prototype.selectSectionBoxes = function(e){

		var $this = $(e.target),
			$container = $this.parent();
		
		if($container.hasClass('active')) {
			$container.find('input[type="checkbox"]').prop('checked', false);
			$container.find('li').removeClass('on');
			$container.removeClass('active');
			$container.parent('.contain-checkboxes').removeClass('active');
			$this.html('Select all');
		}
		else {
			$container.find('input[type="checkbox"]').prop('checked', true);
			$container.find('li').addClass('on');
			$container.addClass('active');
			$this.html('Deselect all');
		}

		return false;
	};

	Filter.prototype.selectAllCheckboxes = function(){
		
		$('.filter-container input[type="checkbox"]').prop('checked', true);
		$('.filter-options li').addClass('on');
		$('.contain-checkboxes').addClass('active');

		return false;
	};

	Filter.prototype.clearAllCheckboxes = function(){
		
		$('.filter-container input[type="checkbox"]').prop('checked', false);
		$('.filter-options li').removeClass('on');
		$('.contain-checkboxes').removeClass('active');

		return false;
	};

	Filter.prototype.getAllFilterOptions = function(e){
		if(e) e.preventDefault();
		
		var	list = {},
			keyword = $('#filter-search-keyword').val() || 0,
			$checkedInputs = $('.filter-container input:checked');
			
		$('.contain-checkboxes').each(function() {
			list[$(this).data('type')] = [];
		});

		if($checkedInputs.length > 0 || keyword !== 0) {

			for(var i=0;i<$checkedInputs.length;i++){
				list[$checkedInputs.eq(i).attr('name')].push($checkedInputs.eq(i).val());
			}
		
		}

		list.keyword = keyword !== 0 ? keyword : null;

		this.prepareData(JSON.stringify(list));

		return false;
	};

	Filter.prototype.addFilterPageOverlay = function(){
		var self = this,
			$div = $('<div />').addClass('filter-page-overlay');

		if($('.filter-page-overlay').length <= 0) {
					
		} else {
			$('.filter-page-overlay').remove();
		}

		return false;
	};

	Filter.prototype.prepareData = function(list){

		bare.postArgs.action = 'more_posts';
		bare.postArgs.posts_per_page = 12;
		bare.postArgs.offset = 0;
		bare.postArgs.post_type = 'make';
		bare.postArgs.filters = list;
		bare.postArgs.paged = 1;
		bare.postArgs.post_status = 'publish';
		
		$('.ajax-load-more').closest('.row').fadeIn();
		
		bare.infiniLoader.runAjax(bare.postArgs);
	};

	Filter.prototype.toggleFilterVisibility = function(){

		$('.filter-container i').toggleClass('filter-down filter-right');

		$('.filter-options').toggleClass('hidden');
		

		//this.addFilterPageOverlay();

		return false;
	};

	Filter.prototype.maintainCheckboxes = function(e){
		var $thisLI = $(e.currentTarget), //li
			$container = $thisLI.parent('ul').parent('div.contain-checkboxes'),
			$checkBox = $thisLI.find('input[type=checkbox]');
	
		if($checkBox.attr('name') === "selectall") { //select all box
			
			this.selectAllBox($thisLI, $container, $checkBox);

		}
		else { //default behaviour of checkboxes that aren't select all

			this.checkedBox($thisLI, $container, $checkBox);
		}

		return false;
	};

	Filter.prototype.selectAllBox = function($thisLI, $container, $checkBox){
		
		if( !$thisLI.hasClass('on')) {
			
			$container.find('li').each(function(){
				$(this).addClass('on');
				$container.addClass('active');
				$(this).find('input[type=checkbox]').prop('checked', true);
			});

			$thisLI.addClass('on');
			$checkBox.prop('checked', true);
		}
		else {
			
			$container.find('li').each(function(){
				$(this).removeClass('on');
				$container.removeClass('active');
				$(this).find('input[type=checkbox]').prop('checked', false);
			});

			$thisLI.removeClass('on');
			$checkBox.prop('checked', false);
		}

	};

	Filter.prototype.checkedBox = function($thisLI, $container, $checkBox){

		$thisLI.toggleClass('on');

		if( $thisLI.hasClass('on') ) {
			$container.addClass('active');
			$checkBox.prop('checked', true);
		}
		else {
			$checkBox.prop('checked', false);
			if($container.find('li.on').length <= 0) {
				$container.removeClass('active');
			}
		}

	};

	return {
		createFilter: createFilter
	};

}();