var bare = bare || {};
var HeaderClass = function() {};

HeaderClass.prototype = function(){

	var Header = function(options){

		this.navCartButton = options.navCartButton || '.nav-cart-item';
		this.navSearchButton = options.navSearchButton || '.nav-search-item';
		this.navCurrencyButton = options.navCurrencyButton || '.nav-currency-item';
		
		this.cartContainer = options.cartContainer || '.nav-cart';
		this.currencyContainer = options.currencyContainer || '.nav-currency';
		this.searchContainer = options.searchContainer || '.nav-search';

		this.allItems = options.allItems || '.topbar-drop';
		this.allLinks = this.navCartButton + ' a, ' + this.navCurrencyButton + ' a, ' + this.navSearchButton + ' a';
		this.topBarHandlers();
		this.mainLinkHelper();
		this.scrollHelper();
	},
	initHeader = function(options) {
		
		var x = new Header(options);

	};

	Header.prototype.scrollHelper = function(){
		if(bare.isMobile) return false;

		var self = this,
			topSpace = ($('#wpadminbar').length) ? $('#wpadminbar').height() : 0,
			standard = topSpace	+ 0,
			fadeStart = topSpace + 30,
			$faqs = $(".page-template-archive-faq-php"),
			$headerContainer = $('#header'),
			$topbarContainer = $('.topbar');

		$(window).scroll(function(){
			var top = $(this).scrollTop();
						
			if(top <= standard) {
				$headerContainer.removeClass('minimise-header');
				$topbarContainer.removeClass('fix-topbar');
				$faqs.removeClass("fixed");
			}

			if(top > fadeStart) {
				$headerContainer.removeClass('minimise-header').addClass('minimise-header');
				$topbarContainer.removeClass('fix-topbar').addClass('fix-topbar');
				$faqs.removeClass("fixed").addClass("fixed");	
			}
			
			self.toogleMainHeaderPosOnTopbarChange();
			
		});

	};

	Header.prototype.toogleMainHeaderPosOnTopbarChange = function(){
		var $header = $('.minimise-header'),
			$topbar = $('.topbar');
			
		$header.css('top', $topbar.height());
		
	};

	//currently inits handlers for the topbar, might expand it to handle all events at later date
	Header.prototype.topBarHandlers = function(){
				
		$(this.navCartButton).on('click', this.showHideCart.bind(this));
		$(this.navSearchButton).on('click', this.showHideSearch.bind(this));
		$(this.navCurrencyButton).on('click', this.showHideLogin.bind(this));

	};

	Header.prototype.mainLinkHelper = function(){
		var $active = $('#header-nav ul li.active');

		$('#header-nav ul li').hoverIntent(
			function(){ //in
				$active.removeClass('active');
			},
			function(){ //out
				$active.addClass('active');
			}
		);
	};

	//TODO: combine with showHideCart, showHideSearch, showHideLogin
	Header.prototype.showHideCart = function(e) {
		var $link = $(e.currentTarget).find('a'),
			isActive = $link.hasClass('active');
		
		$(this.allLinks).removeClass('active');
		$(this.allItems).removeClass('visible');
		$('.topbar').addClass('closed');
		
		if(!isActive) {
			$link.addClass('active');
			$(this.cartContainer).addClass('visible');
			$('.topbar').removeClass('closed');
		}
		this.toogleMainHeaderPosOnTopbarChange();
		
		return false;
	};
	
	//TODO: combine with showHideCart, showHideSearch, showHideLogin
	Header.prototype.showHideSearch = function(e) {
		var $link = $(e.currentTarget).find('a'),
			status = $link.attr('class');
		
		$(this.allLinks).removeClass('active');
		$(this.allItems).removeClass('visible');
		$('.topbar').addClass('closed');

		if(status !== 'active') {
			$link.addClass('active');
			$(this.searchContainer).addClass('visible');
			$('.topbar').removeClass('closed');
		}
		
		this.toogleMainHeaderPosOnTopbarChange();
		
		return false;
	};
	
	//TODO: combine with showHideCart, showHideSearch, showHideLogin
	Header.prototype.showHideLogin = function(e) {
		var $link = $(e.currentTarget).find('a'),
			status = $link.attr('class');
		
		$(this.allLinks).removeClass('active');
		$(this.allItems).removeClass('visible');
		$('.topbar').addClass('closed');

		if(status !== 'active') {
			$link.addClass('active');
			$(this.currencyContainer).addClass('visible');
			$('.topbar').removeClass('closed');
		}

		this.toogleMainHeaderPosOnTopbarChange();
		
		return false;
	};
	
	/**
	 * Terribly named div container for clicks off of the topbar and topbar dropdown
	 * @return {[type]} [description]
	 */
	Header.prototype.clickOverlayBackground = function(){
		var self = this,
			$div = $('<div />').addClass('topbar-page-overlay'),
			oneVisible = false;

		$(this.allItems).each(function(){
			if($(this).hasClass('visible')) {
				oneVisible = true;
				return false;
			}
		});

		// if no div present put one in
		if( ($('.topbar-page-overlay').length <= 0) && (oneVisible) ) {

			//add it to body
			$div.appendTo('body');

			//add event handler to remove it
			$('.topbar-page-overlay').one('click', function(){
				$(self.allLinks).removeClass('active');
				$(self.allItems).removeClass('visible');
				$('.topbar-page-overlay').remove();
			});

		} else {
			$('.topbar-page-overlay').remove();
		}
	};

	return {
		initHeader: initHeader
	};
}();