var bare = bare || {};
/**
 * very much a functional programming style, abstracted into seperate functions so we can amend / edit and rebuild if required.
 */
InfiniLoad = function(){};

InfiniLoad.prototype = function(){

	var loadOn = true, //bool
		prevFilters = false, //store the filters
		$appendLocation = null, //jquery elm
		$ajaxLoadMore = null, //jquery elm
		ajaxOn = 0, //int
		$filter = null; //jquery elm
	
	init = function(){

		$appendLocation = $('.ajaxto'); //jquery elm
		$ajaxLoadMore = $(".ajax-load-more"); //jquery elm
		ajaxOn = $ajaxLoadMore.length; //int
		$filter = $('.filter-container'); //jquery elm

		bare.postArgs.paged = 2;
			
		$("body").on("click", ".ajax-more-button", function(){
			$(".ajax-more-button").hide();
			$(".ajax-loading-image").animate({"opacity": 1}, 100);
			prepareData();

			return false;
		});
		
	},
	
	prepareData = function(){

		bare.postArgs.action = 'more_posts';
		bare.postArgs.post_status = 'publish';
		bare.postArgs.post_type = $ajaxLoadMore.data('infini-load');
		if($ajaxLoadMore.data('infini-category') !== "") bare.postArgs.category_name = $ajaxLoadMore.data('infini-category');
		bare.postArgs.twitter_i = $ajaxLoadMore.data('twitter-i');
		bare.postArgs.posts_per_page = 12;
				
		// if(bare.postArgs.post_type === 'product') {
		// 	console.log("we are product page");
		// 	bare.postArgs.posts_per_page = 10;
		// 	bare.postArgs.offset = bare.postArgs.posts_per_page * (bare.postArgs.paged - 1);
		// }

		$ajaxLoadMore.closest('.row').fadeIn();
	
		console.log("postargs", bare.postArgs);

		runAjax(bare.postArgs);
	},
	
	runAjax = function(dataObj){
		var self = this;

		loadOn = false;

		console.log(ajaxOn, dataObj);
			
		if(ajaxOn || dataObj.paged === 1) {
			console.log("running ajax");

			$ajaxLoadMore.closest('.row').fadeIn(300);

			$.ajax({
				url: '/wp-admin/admin-ajax.php',
				data: dataObj,
				success: function(data) {
		
					$ajaxLoadMore.closest('.row').fadeOut(300, function(){
						$(this).remove();
					});

					$('.ajax-load-more').parent().parent('.row').remove();

					if(dataObj.filters || prevFilters){
						
						if(compare(dataObj.filters, prevFilters)){
							
							if(prevFilters === "product-page") {
						
								if(dataObj.product_cat) $appendLocation.empty();
							}
						}
						else {
							$appendLocation.empty();
						}
					}

					$appendLocation.append(data);
					bare.postArgs.paged++;

					ajaxOn = $(data).find('.ajax-load-more').length;
					prevFilters = dataObj.filters;
					loadOn = true;
					
				},
				error: function(errorThrown){
				
					console.log("ERROR: ");
					console.log(errorThrown);
				
				}
			});
		}
	};

	return {
		init: init,
		prepareData: prepareData,
		runAjax: runAjax

	};

		//TODO: move these from here to utils
		//=============================================================
		// stolen array comparison funcs below - 
		// http://stackoverflow.com/questions/3243275/javascript-arrays-checking-two-arrays-of-objects-for-same-contents-ignoring-o
		//=============================================================
		function inArray(array, el) {
			
			for ( var i = array.length; i--; ) {
				if ( array[i] === el ) return true;
			}
			
			return false;
		}

		function isEqArrays(arr1, arr2) {
			
			if ( arr1.length !== arr2.length ) {
				return false;
			}
			
			for ( var i = arr1.length; i--; ) {
				if ( !inArray( arr2, arr1[i] ) ) {
					return false;
				}
			}
			
			return true;
		}

		//=============================================================
		//http://stackoverflow.com/questions/7837456/comparing-two-arrays-in-javascript
		//=============================================================
		function compare(first, array) {
			// if the other array is a falsy value, return
			if (!array)
				return false;

			// compare lengths - can save a lot of time
			if (first.length != array.length)
				return false;

			for (var i = 0, l=first.length; i < l; i++) {
				// Check if we have nested arrays
				if (first[i] instanceof Array && array[i] instanceof Array) {
					// recurse into the nested arrays
					if (!first[i].compare(array[i]))
						return false;
				}
				else if (first[i] != array[i]) {
					// Warning - two different object instances will never be equal: {x:20} != {x:20}
					return false;
				}
			}
			return true;
		}
}();