/**
 * Basic init script
 */
//TODO: SCRIPTS.JS SHOULD REALLY BE COMBINED WITH INIT.JS
		
var staffOptions = {
	'peopleRow': '.staff-row',
	'appendClass': 'mobile staff list-slider',
	'itemWidth': 200
};

var seniorOptions = {
	'peopleRow': '.senior-staff-row',
	'appendClass': 'mobile senior list-slider',
	'itemWidth': 200
};

var filterOptions = {
	'filterContainer': '.filter-container',
	'listClass': '.filter-list:not(.faq)',
	'titleItem': '.title',
	'selectedItems': '.selected'
};

//want to namespace this and put them in an options js file.
var dotGridOptionsSmallTitles = {
	'rows': '3',
	'columns': '96',
	'itemClass': 'dot',
	'rowClass': 'image-row',
	'targetLocation': '.header-bg',
	'isInteractive': 'false'
};

var dotGridOptionsHeader = {
	'rows': '5',
	'columns': '79',
	'itemClass': 'dot',
	'rowClass': 'image-row',
	'targetLocation': '#header-dot-grid',
	'isInteractive': 'false'
};

var dotGridOptionsHeaderMobile = {
	'rows': '5',
	'columns': '80',
	'itemClass': 'dot',
	'rowClass': 'image-row',
	'targetLocation': '#header-mobile-dot-grid',
	'isInteractive': 'false'
};

var dotGridOptionsMakeTut = {
	'rows': '3',
	'columns': '71',
	'itemClass': 'dot',
	'rowClass': 'image-row',
	'targetLocation': '#make-single-separator',
	'isInteractive': 'false'
};

var sliderOptions = {};

sliderOptions.home = {
	autoScaleSlider: false,
	imageScaleMode: "fill",
	navigateByClick: false,
	//autoScaleSliderWidth: 967,
	//autoScaleSliderHeight: 410,
	autoPlay: {
		enabled: true,
		pauseOnHover: true,
		delay: 4000
	}
};

sliderOptions.singleProduct = {
	fadeinLoadedSlide: true,
	controlNavigationSpacing: 0,
	controlNavigation: 'thumbnails',
	thumbs: {
		orientation: 'vertical',
		spacing: 8,
		firstMargin: false,
		appendSpan: false
	},
	autoScaleSlider: false,
	imageScaleMode: "fill",
	//autoScaleSliderWidth: 720,
	//autoScaleSliderHeight: 415,
	autoPlay: {
		enabled: false, //CHANGE THIS CHANGE THIS CHANGE THIS CHANGE THIS
		pauseOnHover: true,
		delay: 4000
	}
};

var sliderArgs = {
	'sliderClass': '.bare-slider',
	'slideClass': '.slide',
	'sliderSupportClass': '.bare-slider-support'
};

var headerOptions = {
	'navCartButton': '.nav-cart-item',
	'navSearchButton': '.nav-search-item',
	'navLoginButton': '.nav-login-item',
	'cartContainer': '.nav-cart',
	'loginContainer': '.nav-login',
	'searchContainer': '.nav-search',
	'allItems' : '.topbar-drop'
};

var productFilteringOptions = {
	'linkContainer': '.products-filtering',
};

var bare = bare || {};
//dont run this if ie
bare.isMobile = false;
bare.header = new HeaderClass();
bare.headerbox = new DotGridClass();
bare.cookies = new bare.Cookies();
bare.slider = new CustomRoyalSlider();
bare.filterDesktop = new FilteringClass();
bare.productFiltering = new ProductFiltering();
bare.peopleSlider = new PeopleClass();
bare.productGallery = new ProductGallery();
bare.infiniLoader = new InfiniLoad();
bare.postArgs = {};
bare.productArgs = {};

jQuery(function($) {

	/* === need to get this out of here and have some sorta init === */
	
	bare.isMobile = ($(window).width() < 768);
	
	//this is a litle bit shit, see line of code above RE bare.isMobile
	// $(window).setBreakpoints({
	// 	distinct: true,
	// 	breakpoints: [768]
	// });

	// $(window).bind('enterBreakpoint768',function() { //this isnt mobile
	// 	bare.isMobile = false;
	// });

	// $(window).bind('exitBreakpoint768',function() { //this is mobile
	// 	bare.isMobile = true;
	// });

	/* === SEE ABOVE need to get this out of here SEE ABOVE === */

	var sliderType = $('.bare-slider').data('type');
	
	bare.header.initHeader(headerOptions);
	//bare.headerbox.createGrid(dotGridOptionsSmallTitles);
	bare.headerbox.createGrid(dotGridOptionsHeader);
	bare.headerbox.createGrid(dotGridOptionsHeaderMobile);
	//bare.headerbox.createGrid(dotGridOptionsMakeTut);
	bare.slider.createSlider(sliderOptions[sliderType], sliderArgs);
	bare.productFiltering.init(productFilteringOptions);
	bare.filterDesktop.createFilter(filterOptions);
	bare.peopleSlider.createPeople(staffOptions);
	bare.peopleSlider.createPeople(seniorOptions);
	bare.productGallery.init();
	bare.infiniLoader.init(); //call init when required, filter must be on page for it to work?
	Tabs.init();
	
	var hasVisited = bare.cookies.hasVisited;

	if(!hasVisited){
		$("#cookie-message").addClass("show");
	}

	$("#cookie-message button").on("click", function(){

		$("#cookie-message").removeClass("show");

		return false;
	});

	//$(document).ready(function(){

		//$('input, textarea').placeholder();

		// $('.lt-ie9 [placeholder]').focus(function() {
		//   var input = $(this);
		//   if (input.val() == input.attr('placeholder')) {
		//     input.val('');
		//     input.removeClass('placeholder');
		//   }
		// }).blur(function() {
		//   var input = $(this);
		//   if (input.val() == '' || input.val() == input.attr('placeholder')) {
		//     input.addClass('placeholder');
		//     input.val(input.attr('placeholder'));
		//   }
		// }).blur().parents('form').submit(function() {
		//   $(this).find('[placeholder]').each(function() {
		//     var input = $(this);
		//     if (input.val() == input.attr('placeholder')) {
		//       input.val('');
		//     }
		//   })
		// });

		if(!Modernizr.svg) {
			$('.logo-blob, .logo-text').each(function(){
				$(this).attr('src', $(this).data('ieFallback'));
			});
		}

		$("#recaptcha_widget_div").appendTo(".comment-form");
		$(".form-submit").appendTo(".comment-form").css({"padding-top": "16px"});

		$('#gallery-main-images').royalSlider({
			keyboardNavEnabled: true,
			controlNavigation: 'thumbnails'
		});

		$('#mobile-nav-button').on('click', function(){
			$(this).find('.sprite').toggleClass('up-arrow down-arrow');
			$('.header-container').toggleClass('expanded');
			$(this).toggleClass('active');
		});

		$(".open-currency-topdown").on("click", function(){
			$(".nav-currency-item a").trigger("click");

			if($(".nav-currency.topbar-drop.visible").length > 0){
				$(this).addClass("active");
			}
			else {
				$(this).removeClass("active");
			}

			return false;
		});

		$('#main').on('click', '.clickable', function(e){
			var $link = $(this).find('a:not(.add-to-cart)');

			if($link.length === 1){
				window.location.href = $link.attr('href');
			}

			return false;
		});

		$("#main").on("click", "a.add-to-cart", function(){
			window.location.href = $(this).attr('href');
			return false;
		});

		// $('.button.create-account').on('click', function(){
		// 	$('#createaccount').prop('checked', true);
			
		// 	$('div.create-account').hide();
		// 	$('div.create-account').slideDown();

		// 	$(this).addClass('active');

		// });

		$('.mobile-title').on('click', function(){

			var $title = $(this),
				itemName = $title.data('mobileItem');
				$items = $('.mobile-content');
			
			if($title.hasClass('no-dropdown')) return false;

			if(bare.isMobile) { //if its mobile
				
				$title.toggleClass('visible'); //toggle clicked header

				$items.each(function(){ //loop through all mobile-content items
					
					if($(this).data('mobileItem') === itemName) { //if content item data is same as title
						$(this).toggleClass('visible'); //toggle visibility of items
					}
				});
		
			}

			return false;
		});


		$(".about-newsletter-link").on("click", function(){
			$("html, body").animate({ scrollTop: $(document).height() }, 450);
			$(this).css("background-color", "#DDDDDD");
			$(".newsletter-signup h3").css("color", "#FFFFFF");
			setTimeout(function(){ $(".newsletter-signup form input[type=email]").focus(); }, 1150);
		});


		
		$(".faq-page-sidebar a").on("click", function(){
	
			if($(".page-template-archive-faq-php.fixed").length > 0){

				var gotoID = $(this).attr("href"),
					$gotoElement = $("" + gotoID + ""),
					offset = $gotoElement.offset(),
					topPos = offset.top;

				$("body, html").animate({scrollTop: topPos - 260}, 0);

				return false;
			}
		});
	//});

});
