var bare = bare || {};
var PeopleClass = function() {};

PeopleClass.prototype = function(){
	var isAnimating = false;
	var People = function(options){
		this.peopleRow = options.peopleRow || ".staff-row";
		this.count = 0;
		this.itemWidth = options.itemWidth || "300";
		this.appendClass = options.appendClass || "mobile people list-slider";
		this.peopleList = $('<div />').addClass('row list-slider-container')
			.append($('<div />').addClass('list-nav'))
			.append($('<div />').addClass('inner-wrapper'));

		this.peopleList.find('.inner-wrapper').append($('<ul />').addClass(this.appendClass));
		
		if($('.mobile.list-slider').length > 1){
			return false;
		} else {
			this.getPeopleData();
			this.eventHandlers();
		}
		
	},
	createPeople = function(options) {
		
		var x = new People(options);

	};

	People.prototype.getPeopleData = function(){

		var $list = $(this.peopleRow).find('.columns').not('.empty').clone().removeClass();

		this.convertToList($list);

	};

	People.prototype.convertToList = function($data) {
		var self = this,
		$appendListItem = $('<li />'),
		first = true;

		this.count = $data.length;

		$data.each(function(){
			
			if(first) {
				$appendListItem.addClass('active');
				first = false;
			} else {
				$appendListItem.removeClass('active');
			}

			self.peopleList.find('ul').append($appendListItem.clone());
			self.peopleList.find('li').last().append(this);

		});

		self.peopleList.find('ul').css('width', self.count * self.itemWidth);

		this.appendToBody();
	};

	People.prototype.appendToBody = function(){
		var self = this;

		this.peopleList.find('.list-nav')
			.append($('<div />').addClass('next'))
			.append($('<div />').addClass('prev'));

		$(this.peopleRow).last()
			.after(this.peopleList);

	};

	People.prototype.eventHandlers = function(){
		var self = this;
		if(!bare.isMobile) {
			$(this.peopleList.find('.prev')).on('click', this.nextItem.bind(this));
			$(this.peopleList.find('.next')).on('click', this.prevItem.bind(this));
		}
		else {
			$(this.peopleList).swipe({
				allowPageScroll: "vertical",
				swipe:function(event, direction, distance, duration, fingerCount) {
					if(direction === "left") self.nextItem();
					if(direction === "right") self.prevItem();
				}
			});
		}
	};

	People.prototype.nextItem = function(){
		var self = this,
			posBeforeUpdate = parseInt(this.peopleList.find('ul').css('margin-left'), 10),
			sliderWidth = this.count * this.itemWidth;

		if(!isAnimating) {
		
			if(((posBeforeUpdate * -1) + 300) >= sliderWidth) {
				return false;
			}

			this.peopleList.find('ul').css('margin-left', '-=' + (self.itemWidth) + 'px');
			
			this.updateCurrentItem('forward');

			this.animationTimer();
		}
		else {
			return false;
		}
	};

	People.prototype.prevItem = function(){
		var self = this,
			posBeforeUpdate = parseInt(this.peopleList.find('ul').css('margin-left'), 10);
		
		if(!isAnimating) {

			if(posBeforeUpdate >= 0) {
				return false;
			}

			this.peopleList.find('ul').css('margin-left', '+=' + (self.itemWidth) + 'px');
			
			this.updateCurrentItem('backward');
			
			this.animationTimer();

		}
		else {
			return false;
		}
	};

	People.prototype.updateCurrentItem = function(direction){
		var currentItem = this.peopleList.find('li.active').removeClass('active').index();
				
		if(direction === 'forward') {
			this.peopleList.find('li').eq(currentItem + 1).addClass('active');
		}
		else {
			this.peopleList.find('li').eq(currentItem - 1).addClass('active');
		}
		
	};

	People.prototype.animationTimer = function(){
		isAnimating = true;
		
		setTimeout(function(){
			isAnimating = false;
		}, 305);
	};

	return {
		createPeople: createPeople
	};
}();